%define anolis_release 1

Name:	     libxudp
Version:     1.0.4
Release:     %{anolis_release}%{?dist}
Summary:     Express UDP(xudp) library
Vendor:      Alibaba
License:     Mulan PSL v2
Url:         https://gitee.com/anolis/libxudp
Source0:     https://gitee.com/anolis/libxudp/releases/download/v%{version}/libxudp-v%{version}.tar.gz
Source1:     libxudp.pc

BuildRequires: kernel-headers >= 4.19.91
BuildRequires: libnl3-devel
BuildRequires: elfutils-libelf-devel
BuildRequires: libcap-devel
BuildRequires: libbpf-devel
BuildRequires: clang
BuildRequires: llvm
BuildRequires: git

%description
Express UDP is a high-performance UDP communication software library based on the xdp socket technology.

# xudp-tools
%package tools
Summary: Express UDP tools.
Requires: %{name} = %{version}-%{release}
%description tools
Express UDP is a high-performance UDP communication software library based on the xdp socket technology.

# devel
%package devel
Summary: Express UDP devel package.
Requires: %{name} = %{version}-%{release}
%description devel
Express UDP is a high-performance UDP communication software library based on the xdp socket technology.

%prep
%autosetup -n %{name}-v%{version} -p1

%build
export CFLAGS=%{nil}
make SO=1

%install
mkdir -p %{buildroot}/usr
mkdir -p %{buildroot}/usr/lib64
mkdir -p %{buildroot}/usr/lib64/pkgconfig
mkdir -p %{buildroot}/usr/include
mkdir -p %{buildroot}/usr/bin
make install prefix=%{buildroot}/usr
cp -p %{SOURCE1} %{buildroot}/usr/lib64/pkgconfig
rm -rf %{buildroot}/usr/lib64/libxudp.a

%clean
rm -rf $RPM_BUILD_ROOT

%files
%{_libdir}/libxudp.so.*

%files tools
%{_bindir}/xudp-route6
%{_bindir}/xudp-echo-server
%{_bindir}/xudp-map
%{_bindir}/xudp-dump
%{_bindir}/xudp-stats
%{_bindir}/xudp-route
%{_bindir}/xudpperf

%files devel
%{_includedir}/xudp.h
%{_libdir}/libxudp.so
%{_libdir}/pkgconfig/libxudp.pc

%changelog
* Tue Jul 22 2025 Philo Lu <lulie@linux.alibaba.com> - 1.0.4-1
- rx: Flush rx fq when group free
- tx: Add lock for txch sharing
- kern: Add access check for ipv6 in xudp_hash()
- bpf: Use lazy logging when prog loading
- ip pkt: init pseudo_ip_id as random
- udp cksum: update algorithm according to kernel
- cksum: fix wrong byte order check in do_csum()
- udp: add checksum for ipv4 udp
- ip: add pseudo random ip id with global variable
- use libbpf to load bpf program

* Thu Apr 13 2023 happy_orange <songnannan@linux.alibaba.com> - 1.0.3-1
- update to 1.0.3

* Thu Apr 13 2023 happy_orange <songnannan@linux.alibaba.com> - 1.0.2-2
- remove the abi and api

* Mon Feb 27 2023 Xuan Zhuo <xuanzhuo@linux.alibaba.com> - 1.0.2-1
- support ipv6
- support python3

* Wed Sep 7 2022 Xuan Zhuo <xuanzhuo@linux.alibaba.com> - 1.0.1-1
- make gcc happy
- use /usr/bin/python2 replace /bin/env python2

* Mon Aug 15 2022 Xuan Zhuo <xuanzhuo@linux.alibaba.com> - 1.0.0-1
- Initial libxudp

